#!/bin/sh

# $Id: dir.sh,v 1.4 2004/10/16 11:01:07 pho Exp $

sleep `../random/random 1 10`
n=`../random/random 1 20`
m=$n

max=`sysctl kern.maxvnodes | sed 's/.* //'`
[ -z "$max" ] && echo "Can not get kern.maxvnodes!" && exit
max=`expr $max - 512`
min=`expr $max / 40`
if [ `../random/random 1 100` -le 5 ]; then
   max=`../random/random $min $max`
else
   max=`expr $max / 2` 
   max=`../random/random 100 $max`
fi
max=`expr $max / $n`

for i in `ls -d p*.d1 2>/dev/null`; do
   ./dir -r $i
done

while [ $n -gt 0 ]; do
   n=`expr $n - 1`
   ./dir -n $max &
done

while [ $m -gt 0 ]; do
   m=`expr $m - 1`
   wait
done
