/* $Id: pthread.c,v 1.1 2004/08/16 10:31:36 pho Exp $ */
#include <sys/types.h>
#include <sys/select.h>
#include <pthread.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#define NUM 1024

volatile int done = 0;

void
handler(int i) {
        exit(0);
}

void *
thr(void *p) {
	int i = 0;

	while (done == 0) {
		pthread_yield();
		if (i++ == 10000) {
			break;
		}
	}

	return p;
}

void
test() {
	pthread_t t[NUM];

	int ret;
	int i;

	done = 0;
	for (i = 0; i < NUM; i++) {
		ret = pthread_create(&t[i], NULL, thr, NULL);

		if (ret != 0) {
			printf("pthread_create returns: %d (%s).\n",
					ret, strerror(ret));
			break;
		}
	}
	done = 1;
	pthread_yield();

}

int main(int argc, char **argv)
{
        int i;

        i = 0;
        signal(SIGALRM, handler);
        alarm(60);
	sleep(2);

	for(;;)
		test();
        return 0;
}
