/* $Id: random.c,v 1.4 2003/08/31 09:04:24 pho Exp $ */

#include <stdio.h>
#include <sys/syscall.h>
#include <stdlib.h>
#include <unistd.h>

int
main(int argc, char **argv) {

	int i, n, mi, min, ma, max, ave;

	if (argc < 3) {
		fprintf(stderr, "Usage: %s <min> <max> {<ave>}\n", argv[0]);
		return(1);
	}

	srandom(getpid());

	sscanf(argv[1], "%d", &min);
	sscanf(argv[2], "%d", &max);
	mi = min;
	ma = max;

	if (argc == 4) {
		sscanf(argv[3], "%d", &ave);
		if ((ave >= min) && (ave <= max)) {
			n = random() % 10 + 1;	/* 1 - 10 */
			if (n < 10) {
				if (ave < (max - min + 1) / 2) {
					ma = ave + (ave - min + 1);
				} else {
					mi = ave - (max - ave + 1);
				}
			}
		} else
			fprintf(stderr, "Average argument: %d is outside %d - %d\n",
					ave, min, max);
	}


/*	fprintf(stderr, "min = %d, max = %d, mi = %d, ma = %d\n", min, max, mi, ma);*/
/*	fprintf(stderr, "i = random()  %% (%d - %d + 1) + %d;\n", ma, mi, mi);*/
	i = random()  % (ma - mi + 1) + mi;
/*	fprintf(stderr, "i = %d\n", i);*/

	fprintf(stdout, "%d\n", i);
	return(0);
}
