/* $Id: yield.c,v 1.3 2004/06/17 08:42:57 pho Exp $ */
#include <sys/types.h>
#include <sys/select.h>
#include <pthread.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>

#define NUM 1024

volatile int done = 0;

void *
thr(void *p) {
	int i = 0;

	while (done == 0) {
		pthread_yield();
		if (i++ == 10000) {
			fprintf(stderr, "Yield test failed!\n");
			break;
		}
	}

	return p;
}

int
main() {
	pthread_t t[NUM];

	int ret;
	int i;

	for (i = 0; i < NUM; i++) {
		ret = pthread_create(&t[i], NULL, thr, NULL);

		if (ret != 0) {
			printf("pthread_create returns: %d (%s).\n",
					ret, strerror(ret));
			break;
		}
	}
	done = 1;
	pthread_yield();

	return 0;
}
