#!/bin/sh

# $Id: fork.sh,v 1.3 2004/08/22 06:58:26 pho Exp $

[ $# -eq 0 ] && sleep `../random/random 1 10`

maxproc=`ulimit -u`
[ -z "$maxproc" ] && exit
proc=`ps aux | wc -l`
maxproc=`expr \( $maxproc - $proc - 100 \) / 2`

if [ $# -eq 0 ]; then
   if [ `../random/random 1 100` -le 5 ]; then
      invocations=`../random/random 1 $maxproc`
   else
      invocations=`../random/random 1 10`
   fi
   echo $invocations >> log
else
   invocations=$maxproc
fi

i=0
host=`hostname`
while [ $i -lt $invocations ]; do
   i=`expr $i + 1`
   ./fork >> fork.log 2>&1 &
done

while [ $invocations -gt 0 ]; do
   invocations=`expr $invocations - 1`
   wait
done
