/* Based on work from don@sandvine.com */

#include <stdlib.h>
#include <stdio.h>
#include <fcntl.h>
#include <unistd.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/stat.h>
/*#include <sys/time.h>*/
#include <sys/wait.h>
#include <sys/resource.h>
#include <string.h>

char buf[16384];
pid_t mypid;

static void
doit() {
	int fd;
	char filename[128];

	srandom(getpid());
	memset(buf, random(), sizeof(buf));
	sprintf(filename, "/tmp/fe%d/template.XXXXXXXXXX", mypid);
	mkstemp(filename);
	fd = open(filename, O_RDWR | O_CREAT | O_TRUNC, 0666);
	if (fd > 0) {
		write(fd, buf, sizeof(buf));
	} else
		perror("open");
	exit(0);
}

int stop = 0;

void
handler(int i) {
	stop = 1;
}

int
main(int argc, char **argv) {
	unsigned int i;
	int s;
	pid_t r;
	char tmpdir[128], cmd[128];

	signal(SIGALRM, handler);
	alarm(60);

	mypid = getpid();
	sprintf(tmpdir, "/tmp/fe%d", mypid);
	if (mkdir(tmpdir, 0777) == -1)
		perror("mkdir");

	for (i = 0; stop == 0; i++) {
		if ((r = fork()) == 0) {
			doit();
		}
		if (r < 0) {
			perror("fork");
			break;
		}
		if ((i > 0 && i % 1000) == 0) {
			while (waitpid(-1, &s, WNOHANG) > 0)
				;
			sprintf(cmd, "rm  %s/*", tmpdir);
			system(cmd);
		}
	}
	while (waitpid(-1, &s, WNOHANG) > 0)
		;
	sprintf(cmd, "rm -rf %s", tmpdir);
	system(cmd);

	return 0;
}
