/* $Id$ */

#include <pthread.h>
#include <stdio.h>
#include <signal.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/select.h>

void
handler(int i) {
	exit(0);
}

void *
thr_routine(void *arg)
{
	for (;;) {
		(void) getpid();
	}
	return (0);
}

int main(int argc, char **argv)
{
	pthread_t td;
	int i;
	
	i = 0;
	signal(SIGALRM, handler);
	alarm(60);

	while (i++ < 75)
		pthread_create(&td, NULL, thr_routine, 0);

	if (argc == 1) {
		for(;;)
			sleep(1);
	} else {
		/* failsafe */
		sleep(120);
		fprintf(stderr, "%s failed!\n", argv[0]);
	}

	return (0);
}
