/* $Id: maxpath.c,v 1.1 2003/06/12 07:39:57 pho Exp $ */
#include <stdio.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <errno.h>
#include <string.h>
#include <sys/param.h>

static int max;

void
error(char *op, char* arg, char* file, int line) {
	fprintf(stderr,"%s. %s. %s (%s:%d)\n",
		op, arg, sys_errlist[errno], file, line);
}

void
mkDir(char *path, int level) {
	char newPath[MAXPATHLEN+10];

	if (mkdir(path, 0770) == -1) {
		error("mkdir", path, __FILE__, __LINE__);
		fprintf(stderr, ") level = %d\n", level);
		exit(2);
	}
	if (level < max) {
		sprintf(newPath,"%s/d", path);
		mkDir(newPath, level+1);
	}
}

int
main(int argc, char **argv) {
	char path[80];

	max = 512;
	umask(0);
	sprintf(path,"d");
	mkDir(path, 1);
	return 0;
}
