#include <pthread.h>
#include <stdio.h>
#include <signal.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

#define KTHREADS 10

void
handler(int i) {
	exit(0);
}

void *
thr_routine(void *arg)
{
	for (;;) {
		(void) getpid();
	}
	return (0);
}

int main(int argc, char **argv)
{
	pthread_t td;
	int i;
	int r;
	
	i = 0;
	signal(SIGALRM, handler);
	alarm(60);

	if ((r = pthread_setconcurrency(KTHREADS)) != 0) {
		fprintf(stderr, "pthread_setconcurrency(%d): %s\n", KTHREADS,
			strerror(r));
		exit(1);
	}

	while (i++ < 100)
		if ((r = pthread_create(&td, NULL, thr_routine, 0)) != 0)
			fprintf(stderr, "pthread_create(): %s\n", strerror(r));

	if (argc == 1) {
		for(;;)
			sleep(1);
	} else {
		/* failsafe */
		sleep(120);
		fprintf(stderr, "%s failed!\n", argv[0]);
	}

	return (0);
}
